#ifndef PLATFORMDEFINES_H
#define PLATFORMDEFINES_H

namespace LibPlatform {

  extern const signed REMOTE_BUTTON_LEFT;
  extern const signed REMOTE_BUTTON_RIGHT;
  extern const signed REMOTE_BUTTON_DOWN;
  extern const signed REMOTE_BUTTON_UP;
  extern const signed REMOTE_BUTTON_PLUS;
  extern const signed REMOTE_BUTTON_2;
  extern const signed REMOTE_BUTTON_1;
  extern const signed REMOTE_BUTTON_B;
  extern const signed REMOTE_BUTTON_A;
  extern const signed REMOTE_BUTTON_MINUS;
  extern const signed REMOTE_BUTTON_HOME;
  extern const signed REMOTE_BUTTON_Z;
  extern const signed REMOTE_BUTTON_C;
  extern const signed REMOTE_BUTTON_START;
  extern const signed REMOTE_BUTTON_SELECT;
  extern const signed REMOTE_BUTTON_SMALL_A;
  extern const signed REMOTE_BUTTON_SMALL_B;
  extern const signed REMOTE_CL_BUTTON_UP;
  extern const signed REMOTE_CL_BUTTON_LEFT;
  extern const signed REMOTE_CL_TRIGGER_ZR;
  extern const signed REMOTE_CL_BUTTON_ZR;
  extern const signed REMOTE_CL_BUTTON_X;
  extern const signed REMOTE_CL_BUTTON_A;
  extern const signed REMOTE_CL_BUTTON_Y;
  extern const signed REMOTE_CL_BUTTON_B;
  extern const signed REMOTE_CL_TRIGGER_ZL;
  extern const signed REMOTE_CL_BUTTON_ZL;
  extern const signed REMOTE_CL_RESERVED;
  extern const signed REMOTE_CL_TRIGGER_R;
  extern const signed REMOTE_CL_BUTTON_R;
  extern const signed REMOTE_CL_BUTTON_PLUS;
  extern const signed REMOTE_CL_BUTTON_HOME;
  extern const signed REMOTE_CL_BUTTON_MINUS;
  extern const signed REMOTE_CL_TRIGGER_L;
  extern const signed REMOTE_CL_BUTTON_L;
  extern const signed REMOTE_CL_BUTTON_DOWN;
  extern const signed REMOTE_CL_BUTTON_RIGHT;
  extern const signed REMOTE_UC_BUTTON_UP;
  extern const signed REMOTE_UC_BUTTON_LEFT;
  extern const signed REMOTE_UC_TRIGGER_ZR;
  extern const signed REMOTE_UC_BUTTON_X;
  extern const signed REMOTE_UC_BUTTON_A;
  extern const signed REMOTE_UC_BUTTON_Y;
  extern const signed REMOTE_UC_BUTTON_B;
  extern const signed REMOTE_UC_TRIGGER_ZL;
  extern const signed REMOTE_UC_RESERVED;
  extern const signed REMOTE_UC_TRIGGER_R;
  extern const signed REMOTE_UC_BUTTON_PLUS;
  extern const signed REMOTE_UC_BUTTON_HOME;
  extern const signed REMOTE_UC_BUTTON_MINUS;
  extern const signed REMOTE_UC_TRIGGER_L;
  extern const signed REMOTE_UC_BUTTON_DOWN;
  extern const signed REMOTE_UC_BUTTON_RIGHT;
  extern const signed REMOTE_UC_BUTTON_STICK_R;
  extern const signed REMOTE_UC_BUTTON_STICK_L;
  extern const signed REMOTE_UC_BUTTON_ZL;
  extern const signed REMOTE_UC_BUTTON_ZR;
  extern const signed REMOTE_UC_BUTTON_L;
  extern const signed REMOTE_UC_BUTTON_R;
  extern const signed REMOTE_DPD_OFF;
  extern const signed REMOTE_DPD_STD;
  extern const signed REMOTE_DPD_EXP;
  extern const signed REMOTE_DPD_FULL;
  extern const signed REMOTE_DPD_MAX_OBJECTS;
  extern const signed REMOTE_DPD_ANGLE;
  extern const signed REMOTE_DPD_IMG_RESO_WX;
  extern const signed REMOTE_DPD_IMG_RESO_WY;
  extern const signed REMOTE_SPEAKER_OFF;
  extern const signed REMOTE_SPEAKER_ON;
  extern const signed REMOTE_SPEAKER_MUTE;
  extern const signed REMOTE_SPEAKER_MUTE_OFF;
  extern const signed REMOTE_SPEAKER_PLAY;
  extern const signed REMOTE_SPEAKER_RESET;
  extern const signed REMOTE_MPLS_OFF;
  extern const signed REMOTE_MPLS_STD;
  extern const signed REMOTE_MPLS_EXP;
  extern const signed REMOTE_MPLS_FS;
  extern const signed REMOTE_MPLS_CL;
  extern const signed REMOTE_MPLS_ZRST;
  extern const signed REMOTE_MPLS_STAT_PLSVLD;
  extern const signed REMOTE_MPLS_STAT_EXTVLD;
  extern const signed REMOTE_MPLS_STAT_YAWSEL;
  extern const signed REMOTE_MPLS_STAT_PITSEL;
  extern const signed REMOTE_MPLS_STAT_ROLSEL;
  extern const signed REMOTE_MPLS_STAT_ATTACH;
  extern const signed REMOTE_EXTGMK_OFF;
  extern const signed REMOTE_EXTGMK_ON;
  extern const signed REMOTE_ACC_RESO;
  extern const signed REMOTE_ACC_MAX;
  extern const signed REMOTE_FS_STICK_RESO;
  extern const signed REMOTE_FS_ACC_RESO;
  extern const signed REMOTE_FS_ACC_MAX;
  extern const signed REMOTE_CL_STICK_RESO;
  extern const signed REMOTE_CL_TRIGGER_RESO;
  extern const signed REMOTE_UC_STICK_RESO;
  extern const signed REMOTE_DEV_CORE;
  extern const signed REMOTE_DEV_FREESTYLE;
  extern const signed REMOTE_DEV_CLASSIC;
  extern const signed REMOTE_DEV_MPLS;
  extern const signed REMOTE_DEV_MPLS_FREESTYLE;
  extern const signed REMOTE_DEV_MPLS_CLASSIC;
  extern const signed REMOTE_DEV_URCC;
  extern const signed REMOTE_DEV_MPLS_FUTURE;
  extern const signed REMOTE_DEV_FUTURE;
  extern const signed REMOTE_DEV_NOT_SUPPORTED;
  extern const signed REMOTE_DEV_NOT_FOUND;
  extern const signed REMOTE_DEV_UNKNOWN;
  extern const signed REMOTE_FMT_CORE;
  extern const signed REMOTE_FMT_CORE_ACC;
  extern const signed REMOTE_FMT_CORE_ACC_DPD;
  extern const signed REMOTE_FMT_FREESTYLE;
  extern const signed REMOTE_FMT_FREESTYLE_ACC;
  extern const signed REMOTE_FMT_FREESTYLE_ACC_DPD;
  extern const signed REMOTE_FMT_CLASSIC;
  extern const signed REMOTE_FMT_CLASSIC_ACC;
  extern const signed REMOTE_FMT_CLASSIC_ACC_DPD;
  extern const signed REMOTE_FMT_CORE_ACC_DPD_FULL;
  extern const signed REMOTE_FMT_MPLS;
  extern const signed REMOTE_FMT_URCC;
  extern const signed REMOTE_STATE_DISABLED;
  extern const signed REMOTE_STATE_ENABLED;
  extern const signed REMOTE_DISABLE_CLEAR;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_1;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_2;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_3;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_4;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_5;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_6;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_7;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_8;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_9;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_10;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_11;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_12;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_13;
  extern const signed REMOTE_DISABLE_WIFI_CHAN_14;
  extern const signed REMOTE_BATTERY_LEVEL_CRITICAL;
  extern const signed REMOTE_BATTERY_LEVEL_LOW;
  extern const signed REMOTE_BATTERY_LEVEL_MEDIUM;
  extern const signed REMOTE_BATTERY_LEVEL_HIGH;
  extern const signed REMOTE_BATTERY_LEVEL_MAX;
  extern const signed REMOTE_LED_CHAN_1;
  extern const signed REMOTE_LED_CHAN_2;
  extern const signed REMOTE_LED_CHAN_3;
  extern const signed REMOTE_LED_CHAN_4;
  extern const signed REMOTE_SYNC_EVT_START;
  extern const signed REMOTE_SYNC_EVT_DONE;
  extern const signed REMOTE_CLEAR_EVT_BUSY;
  extern const signed REMOTE_CLEAR_EVT_START;
  extern const signed REMOTE_CLEAR_EVT_DONE;
  extern const signed REMOTE_ADDR_LEN;
  extern const signed REMOTE_STRM_INTERVAL;
  extern const signed REMOTE_STICK_CLAMP_OCTA_WITH_PLAY;
  extern const signed REMOTE_STICK_CLAMP_OCTA_WITHOUT_PLAY;
  extern const signed REMOTE_STICK_CLAMP_CIRCLE_WITH_PLAY;
  extern const signed REMOTE_STICK_CLAMP_CIRCLE_WITHOUT_PLAY;
  extern const signed REMOTE_TRIGGER_FIXED_BASE;
  extern const signed REMOTE_TRIGGER_INDIVIDUAL_BASE;
  extern const signed REMOTE_ACC_CLAMP_CUBE;
  extern const signed REMOTE_ACC_CLAMP_SPHERE;
  extern const signed REMOTE_SENSOR_BAR_POS_BOTTOM;
  extern const signed REMOTE_SENSOR_BAR_POS_TOP;
  extern const signed REMOTE_MEM_GAMEDATA_LEN;
  extern const signed REMOTE_SYNC_TYPE_STD;
  extern const signed REMOTE_SYNC_TYPE_SMP;
  extern const signed REMOTE_MPLS_TYPE_INTEGRATED;
  extern const signed REMOTE_MPLS_TYPE_STANDARD;
  extern const signed REMOTE_MPLS_TYPE_READING;
  extern const signed REMOTE_BUTTON_LEFT;
  extern const signed REMOTE_BUTTON_RIGHT;
  extern const signed REMOTE_BUTTON_DOWN;
  extern const signed REMOTE_BUTTON_UP;
  extern const signed REMOTE_BUTTON_A;
  extern const signed REMOTE_BUTTON_B;
  extern const signed REMOTE_BUTTON_HOME;
  extern const signed REMOTE_BUTTON_PLUS;
  extern const signed REMOTE_BUTTON_MINUS;
  extern const signed REMOTE_BUTTON_1;
  extern const signed REMOTE_BUTTON_2;
  extern const signed REMOTE_BUTTON_Z;
  extern const signed REMOTE_BUTTON_C;
  extern const signed REMOTE_CL_BUTTON_UP;
  extern const signed REMOTE_CL_BUTTON_LEFT;
  extern const signed REMOTE_CL_TRIGGER_ZR;
  extern const signed REMOTE_CL_BUTTON_ZR;
  extern const signed REMOTE_CL_BUTTON_X;
  extern const signed REMOTE_CL_BUTTON_A;
  extern const signed REMOTE_CL_BUTTON_Y;
  extern const signed REMOTE_CL_BUTTON_B;
  extern const signed REMOTE_CL_TRIGGER_ZL;
  extern const signed REMOTE_CL_BUTTON_ZL;
  extern const signed REMOTE_CL_RESERVED;
  extern const signed REMOTE_CL_TRIGGER_R;
  extern const signed REMOTE_CL_BUTTON_R;
  extern const signed REMOTE_CL_BUTTON_PLUS;
  extern const signed REMOTE_CL_BUTTON_HOME;
  extern const signed REMOTE_CL_BUTTON_MINUS;
  extern const signed REMOTE_CL_TRIGGER_L;
  extern const signed REMOTE_CL_BUTTON_L;
  extern const signed REMOTE_CL_BUTTON_DOWN;
  extern const signed REMOTE_CL_BUTTON_RIGHT;
  extern const signed REMOTE_UC_BUTTON_UP;
  extern const signed REMOTE_UC_BUTTON_LEFT;
  extern const signed REMOTE_UC_TRIGGER_ZR;
  extern const signed REMOTE_UC_BUTTON_ZR;
  extern const signed REMOTE_UC_BUTTON_X;
  extern const signed REMOTE_UC_BUTTON_A;
  extern const signed REMOTE_UC_BUTTON_Y;
  extern const signed REMOTE_UC_BUTTON_B;
  extern const signed REMOTE_UC_TRIGGER_ZL;
  extern const signed REMOTE_UC_BUTTON_ZL;
  extern const signed REMOTE_UC_RESERVED;
  extern const signed REMOTE_UC_TRIGGER_R;
  extern const signed REMOTE_UC_BUTTON_R;
  extern const signed REMOTE_UC_BUTTON_PLUS;
  extern const signed REMOTE_UC_BUTTON_HOME;
  extern const signed REMOTE_UC_BUTTON_MINUS;
  extern const signed REMOTE_UC_TRIGGER_L;
  extern const signed REMOTE_UC_BUTTON_L;
  extern const signed REMOTE_UC_BUTTON_DOWN;
  extern const signed REMOTE_UC_BUTTON_RIGHT;
  extern const signed REMOTE_UC_BUTTON_STICK_L;
  extern const signed REMOTE_UC_BUTTON_STICK_R;
  extern const signed REMOTE_BUTTON_MASK;
  extern const signed REMOTE_URCC_BUTTON_MASK;
  extern const signed REMOTE_BUTTON_RPT;
  extern const signed REMOTE_RING_BUFS;
  extern const signed REMOTE_MAX_READ_BUFS;
  extern const signed REMOTE_READ_ERR_NONE;
  extern const signed REMOTE_READ_ERR_NO_DATA;
  extern const signed REMOTE_READ_ERR_NO_CONTROLLER;
  extern const signed REMOTE_READ_ERR_SETUP;
  extern const signed REMOTE_READ_ERR_LOCKED;
  extern const signed REMOTE_READ_ERR_INIT;
  extern const signed REMOTE_WBC_ERR_EXIST;
  extern const signed REMOTE_WBC_ERR_NONE;
  extern const signed REMOTE_WBC_ERR_NO_BATTERY;
  extern const signed REMOTE_WBC_ERR_SETUP;
  extern const signed REMOTE_WBC_ERR_WRONG_TEMP;
  extern const signed REMOTE_WBC_ERR_WRONG_ZERO;
  extern const signed REMOTE_WBC_ERR_WEIGHT_OVER;
  extern const signed REMOTE_WBC_ERR_CALIBRATION;
  extern const signed REMOTE_WBC_ERR_NO_ZEROPOINT;
  extern const signed REMOTE_WBC_ERR_ZEROPOINT;
  extern const signed REMOTE_WBC_ERR_TGC_READY;
  extern const signed REMOTE_WBC_ERR_TGC_NONE;
  extern const signed REMOTE_WBC_ERR_TGC_UNSTABLE;
  extern const signed REMOTE_WBC_ERR_TGC_UNKNOWN;
  extern const signed REMOTE_WBC_ERR_TGC_TIMEOUT;
  extern const signed REMOTE_WBC_ERR_TGC_BUSY;

  extern const signed GAMEPADBASE_CHAN0;
  extern const signed GAMEPADBASE_CHAN1;
  extern const signed GAMEPADBASE_MAX_CONTROLLERS;
  extern const signed GAMEPADBASE_BUTTON_LEFT;
  extern const signed GAMEPADBASE_BUTTON_RIGHT;
  extern const signed GAMEPADBASE_BUTTON_UP;
  extern const signed GAMEPADBASE_BUTTON_DOWN;
  extern const signed GAMEPADBASE_BUTTON_A;
  extern const signed GAMEPADBASE_BUTTON_B;
  extern const signed GAMEPADBASE_BUTTON_X;
  extern const signed GAMEPADBASE_BUTTON_Y;
  extern const signed GAMEPADBASE_BUTTON_HOME;
  extern const signed GAMEPADBASE_TRIGGER_ZR;
  extern const signed GAMEPADBASE_TRIGGER_ZL;
  extern const signed GAMEPADBASE_TRIGGER_R;
  extern const signed GAMEPADBASE_TRIGGER_L;
  extern const signed GAMEPADBASE_BUTTON_TV;
  extern const signed GAMEPADBASE_BUTTON_PLUS;
  extern const signed GAMEPADBASE_BUTTON_MINUS;
  extern const signed GAMEPADBASE_BUTTON_SYNC;
  extern const signed GAMEPADBASE_BUTTON_POWER;
  extern const signed GAMEPADBASE_BUTTON_STICK_R;
  extern const signed GAMEPADBASE_BUTTON_STICK_L;
  extern const signed GAMEPADBASE_BATTERY_LEVEL_CHARGE;
  extern const signed GAMEPADBASE_BATTERY_LEVEL_SHUTDOWN;
  extern const signed GAMEPADBASE_BATTERY_LEVEL_CRITICAL;
  extern const signed GAMEPADBASE_BATTERY_LEVEL_LOW;
  extern const signed GAMEPADBASE_BATTERY_LEVEL_MEDIUM;
  extern const signed GAMEPADBASE_BATTERY_LEVEL_HIGH;
  extern const signed GAMEPADBASE_BATTERY_LEVEL_MAX;
  extern const signed GAMEPADBASE_ERR_NONE;
  extern const signed GAMEPADBASE_ERR_NO_CONTROLLER;
  extern const signed GAMEPAD_MAX_CONTROLLERS;
  extern const signed GAMEPAD_BUTTON_LEFT;
  extern const signed GAMEPAD_BUTTON_RIGHT;
  extern const signed GAMEPAD_BUTTON_DOWN;
  extern const signed GAMEPAD_BUTTON_UP;
  extern const signed GAMEPAD_BUTTON_A;
  extern const signed GAMEPAD_BUTTON_B;
  extern const signed GAMEPAD_BUTTON_X;
  extern const signed GAMEPAD_BUTTON_Y;
  extern const signed GAMEPAD_BUTTON_TV;
  extern const signed GAMEPAD_BUTTON_HOME;
  extern const signed GAMEPAD_TRIGGER_ZR;
  extern const signed GAMEPAD_TRIGGER_ZL;
  extern const signed GAMEPAD_TRIGGER_R;
  extern const signed GAMEPAD_TRIGGER_L;
  extern const signed GAMEPAD_BUTTON_ZR;
  extern const signed GAMEPAD_BUTTON_ZL;
  extern const signed GAMEPAD_BUTTON_R;
  extern const signed GAMEPAD_BUTTON_L;
  extern const signed GAMEPAD_BUTTON_STICK_R;
  extern const signed GAMEPAD_BUTTON_STICK_L;
  extern const signed GAMEPAD_BUTTON_STICKL_R_EMULATION_LEFT;
  extern const signed GAMEPAD_BUTTON_STICKL_R_EMULATION_RIGHT;
  extern const signed GAMEPAD_BUTTON_STICKL_R_EMULATION_UP;
  extern const signed GAMEPAD_BUTTON_STICKL_R_EMULATION_DOWN;
  extern const signed GAMEPAD_BUTTON_STICKL_L_EMULATION_LEFT;
  extern const signed GAMEPAD_BUTTON_STICKL_L_EMULATION_RIGHT;
  extern const signed GAMEPAD_BUTTON_STICKL_L_EMULATION_UP;
  extern const signed GAMEPAD_BUTTON_STICKL_L_EMULATION_DOWN;
  extern const signed GAMEPAD_BUTTON_PLUS;
  extern const signed GAMEPAD_BUTTON_MINUS;
  extern const signed GAMEPAD_BUTTON_1;
  extern const signed GAMEPAD_BUTTON_2;
  extern const signed GAMEPAD_BUTTON_MASK;
  extern const signed GAMEPAD_PLUS_BUTTON_MASK;
  extern const signed GAMEPAD_BUTTON_RPT;
  extern const signed GAMEPAD_RING_BUFS;
  extern const signed GAMEPAD_MAX_READ_BUFS;
  extern const signed GAMEPAD_READ_ERR_NONE;
  extern const signed GAMEPAD_READ_ERR_NO_DATA;
  extern const signed GAMEPAD_READ_ERR_NO_CONTROLLER;
  extern const signed GAMEPAD_READ_ERR_SETUP;
  extern const signed GAMEPAD_READ_ERR_LOCKED;
  extern const signed GAMEPAD_READ_ERR_INIT;
  extern const signed GAMEPAD_BUTTON_PROC_MODE_LOOSE;
  extern const signed GAMEPAD_BUTTON_PROC_MODE_TIGHT;
  extern const signed GAMEPAD_TP_TOUCH_OFF;
  extern const signed GAMEPAD_TP_TOUCH_ON;
  extern const signed GAMEPAD_TP_VALIDITY_VALID;
  extern const signed GAMEPAD_TP_VALIDITY_INVALID_X;
  extern const signed GAMEPAD_TP_VALIDITY_INVALID_Y;
  extern const signed GAMEPAD_TP_VALIDITY_INVALID_XY;
  extern const signed GAMEPAD_MOTOR_PATTERN_SIZE_MAX;
  extern const signed GAMEPAD_MOTOR_PATTERN_LENGTH_MAX;
  extern const signed GAMEPAD_BATTERY_LEVEL_CHARGE;
  extern const signed GAMEPAD_BATTERY_LEVEL_SHUTDOWN;
  extern const signed GAMEPAD_BATTERY_LEVEL_CRITICAL;
  extern const signed GAMEPAD_BATTERY_LEVEL_LOW;
  extern const signed GAMEPAD_BATTERY_LEVEL_MEDIUM;
  extern const signed GAMEPAD_BATTERY_LEVEL_HIGH;
  extern const signed GAMEPAD_BATTERY_LEVEL_MAX;
  extern const signed GAMEPAD_EXTERNAL_MIC_ON;

  extern const signed Keyboard_Void;
  extern const signed Keyboard_Error;
  extern const signed Keyboard_Mod_Shift;
  extern const signed Keyboard_Mod_AltGr;
  extern const signed Keyboard_Lang_Toggle;
  extern const signed Keyboard_Num_Lock;
  extern const signed Keyboard_Caps_Lock;
  extern const signed Keyboard_Mod_Control;
  extern const signed Keyboard_Mod_Alt;
  extern const signed Keyboard_Mod_GUI;
  extern const signed Keyboard_Mod_Extra;
  extern const signed Keyboard_Print_Screen;
  extern const signed Keyboard_Scroll_Lock;
  extern const signed Keyboard_Pause;
  extern const signed Keyboard_Application;
  extern const signed Keyboard_Katakana_Hiragana;
  extern const signed Keyboard_Henkan;
  extern const signed Keyboard_Muhenkan;
  extern const signed Keyboard_Kanji;
  extern const signed Keyboard_Katakana;
  extern const signed Keyboard_Hiragana;
  extern const signed Keyboard_Zenkaku_Hankaku;
  extern const signed Keyboard_Hangul_English;
  extern const signed Keyboard_Hanja;
  extern const signed Keyboard_F1;
  extern const signed Keyboard_F2;
  extern const signed Keyboard_F3;
  extern const signed Keyboard_F4;
  extern const signed Keyboard_F5;
  extern const signed Keyboard_F6;
  extern const signed Keyboard_F7;
  extern const signed Keyboard_F8;
  extern const signed Keyboard_F9;
  extern const signed Keyboard_F10;
  extern const signed Keyboard_F11;
  extern const signed Keyboard_F12;
  extern const signed Keyboard_Keypad_Comma;
  extern const signed Keyboard_Keypad_Period;
  extern const signed Keyboard_Keypad_0;
  extern const signed Keyboard_Keypad_1;
  extern const signed Keyboard_Keypad_2;
  extern const signed Keyboard_Keypad_3;
  extern const signed Keyboard_Keypad_4;
  extern const signed Keyboard_Keypad_5;
  extern const signed Keyboard_Keypad_6;
  extern const signed Keyboard_Keypad_7;
  extern const signed Keyboard_Keypad_8;
  extern const signed Keyboard_Keypad_9;
  extern const signed Keyboard_Keypad_Slash;
  extern const signed Keyboard_Keypad_Asterisk;
  extern const signed Keyboard_Keypad_Minus;
  extern const signed Keyboard_Keypad_Plus;
  extern const signed Keyboard_Keypad_Equals;
  extern const signed Keyboard_Keypad_Enter;
  extern const signed Keyboard_Keypad_Delete;
  extern const signed Keyboard_Keypad_Insert;
  extern const signed Keyboard_Keypad_End;
  extern const signed Keyboard_Keypad_Down_Arrow;
  extern const signed Keyboard_Keypad_Page_Down;
  extern const signed Keyboard_Keypad_Left_Arrow;
  extern const signed Keyboard_Keypad_Space;
  extern const signed Keyboard_Keypad_Right_Arrow;
  extern const signed Keyboard_Keypad_Home;
  extern const signed Keyboard_Keypad_Up_Arrow;
  extern const signed Keyboard_Keypad_Page_Up;
  extern const signed Keyboard_Delete;
  extern const signed Keyboard_Insert;
  extern const signed Keyboard_End;
  extern const signed Keyboard_Down_Arrow;
  extern const signed Keyboard_Page_Down;
  extern const signed Keyboard_Left_Arrow;
  extern const signed Keyboard_Right_Arrow;
  extern const signed Keyboard_Home;
  extern const signed Keyboard_Up_Arrow;
  extern const signed Keyboard_Page_Up;
  extern const signed Keyboard_Backspace;
  extern const signed Keyboard_Tab;
  extern const signed Keyboard_Enter;
  extern const signed Keyboard_Escape;
  extern const signed Keyboard_Space;

  extern const signed MEDIA_BASELINE_PROFILE;
  extern const signed MEDIA_MAIN_PROFILE;
  extern const signed MEDIA_HIGH_PROFILE;

  extern const signed DEBUGIO_HANDLE_INVALID;
  extern const signed DEBUGIO_CHANNEL_OPTION_READ;
  extern const signed DEBUGIO_CHANNEL_OPTION_WRITE;
  extern const signed DEBUGIO_CHANNEL_OPTION_READ_WRITE;
  extern const signed DEBUGIO_STATUS_NEW_CONNECTION;
  extern const signed DEBUGIO_STATUS_OK;
  extern const signed DEBUGIO_STATUS_INVALID_CHANNEL_NAME;
  extern const signed DEBUGIO_STATUS_NO_CONNECTIONS;
  extern const signed DEBUGIO_STATUS_NO_CHANNELS;
  extern const signed DEBUGIO_STATUS_INVALID_HANDLE;
  extern const signed DEBUGIO_STATUS_NO_CLIENT_TXN_BUF_AVAILABLE;
  extern const signed DEBUGIO_STATUS_OUT_OF_MEMORY;
  extern const signed DEBUGIO_STATUS_INVALID_PARAM;
  extern const signed DEBUGIO_STATUS_NOT_INITIALIZED;
  extern const signed DEBUGIO_STATUS_INVALID_OPERATION;

  extern const signed SYSTEM_DYNLOAD_ERR_NONE;
  extern const signed SYSTEM_SDK_VERSION;
  extern const signed SYSTEM_SDK_VERSION_STRING;
  extern const double SYSTEM_TIMER_CLOCK;
  extern const signed SYSTEM_MESSAGE_BLOCK;
  extern const signed SYSTEM_MESSAGE_NOBLOCK;
  extern const signed SYSTEM_MESSAGE_HIGH_PRIORITY;

  extern const signed SSL_RVAL_INVALID_NSSL_CTX;
}



namespace LibPlatform {
  typedef enum _KeyboardModState {
    Keyboard_MS_CTRL		 = 0x0001,
    Keyboard_MS_SHIFT		 = 0x0002,
    Keyboard_MS_ALT		 = 0x0004,
    Keyboard_MS_GUI		 = 0x0008,
    Keyboard_MS_EXTRA		 = 0x0010,
    Keyboard_MS_ALTGR		 = 0x0020,
    Keyboard_MS_LANG1		 = 0x0040,
    Keyboard_MS_LANG2		 = 0x0080,
    Keyboard_MS_NUM_LOCK	 = 0x0100,
    Keyboard_MS_CAPS_LOCK	 = 0x0200,
    Keyboard_MS_SCROLL_LOCK = 0x0400,
    Keyboard_MS_SHIFTED_KEY = 0x0800, 
    Keyboard_MS_SET_ALL	 = 0x1000,
    Keyboard_MS_NULL		 = 0x0000
  } KeyboardModState;
}

#endif//PLATFORMDEFINES_H