/*---------------------------------------------------------------------------*

  Copyright 2012 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#ifndef _LIBSHIM_MEMORY_H_
#define _LIBSHIM_MEMORY_H_

#include <stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif

void *shim_Realloc(void *pAddress, size_t newByteSize);
void shim_SetRealloc(void* (*shim_ReallocCB)(void *pAddress, size_t newByteSize));

#ifdef __cplusplus
}
#endif

#endif

